#!/usr/bin/perl

eval "use Algorithm::Diff qw(sdiff)"; $hasdiff = $@ ? 0 : 1;
eval "use File::Find"; $hasfind = $@ ? 0 : 1;
eval "use URI::Escape"; $hasescape = $@ ? 0 : 1;

require './etcupdate-lib.pl';
&ReadParse();

&header("etc-Update","");
print "<hr>\n";

if ($hasdiff && $hasfind && $hasescape) {
    if ($in{'showdiff'} ne '') {
	show_diff();    
    }
    if ($in{'save'} eq "Save") {
	save_files();    
    }
    print_list();
}
else {
    if (!$hasdiff) {
	printf "Perl-Module Algorithm::Diff not found!<br>\n";
    }
    if (!$hasescape) {
	printf "Perl-Module URI::Escape not found!<br>\n";
    }
    if (!$hasfind) {
	printf "Perl-Module File::Find not found!<br>\n";
    }
    

}
&footer("", "System");

sub show_diff {
    get_files();
    my @files=keys(%filelist);

    foreach (@files) {
	$name = uri_escape($_);
	if ($name eq $in{'showdiff'}) {
	    print "<table>\n";    
	    print "<tr><td>$_</td><td>==></td><td>$filelist{$_}</td></tr>\n";
	    @seq1 = load_file($_);
	    @seq2 = load_file($filelist{$_});
	    @diffs = sdiff(\@seq1, \@seq2);
	    for ($i=i;$i<=$#diffs;$i++) {
		@param = $diffs[$i];
		print_diff(@param);
	    }
	    print "</table><hr>\n";    

	}
    }
}

sub print_diff {
    @seq = shift;
    if ($seq[0][0] eq "-") {
        print "<tr>\n";
	print "<td><font color='#ff0000'>".$seq[0][1]."</font></td><td align=center>-</td><td></td>";
        print "</tr>\n";

    }
    elsif ($seq[0][0] eq '+') {
        print "<tr>\n";
	print "<td></td><td align=center>+</td><td><font color='#00ff00'>".$seq[0][2]."</font></td>";
        print "</tr>\n";

    }
    elsif ($seq[0][0] eq 'c') {
        print "<tr>\n";
	print "<td><font color='#0000ff'>".$seq[0][1]."</font></td><td align=center>&gt;</td><td><font color='#0000ff'>".$seq[0][2]."</font></td>";
        print "</tr>\n";

    }
    elsif ($seq[0][0] eq 'u') {
    }
}

sub save_files {
    get_files();
    my @files=keys(%filelist);
    $first=1;
    foreach (@files) {
	$name = uri_escape($_);
	if ($in{$name} eq "del_new") {
	    if ($first==1) {
		$first = 0;
		print &ui_columns_start(["File","Action"]);		
            }
	    print &ui_columns_row([$filelist{$_},"delete"]);
	    unlink ($filelist{$_});
	}
	elsif ($in{$name} eq "take_new") {
	    if ($first==1) {
		$first = 0;
		print &ui_columns_start(["File","Action"]);		
            }
	    print &ui_columns_row([$_,"replace by ". $filelist{$_}]);
	    rename ($filelist{$_},$_);
	}
    }
    if ($first==1) {
	print "Nothing to do!\n";
    }
    else {
	print &ui_columns_end();
    }
    print "<hr>";


}

sub print_list {

    get_files();
    my @files=keys(%filelist);
    
    if ($#files<0) {
	printf "No new config-files found!<br>";
    }
    else {
    
        print &ui_form_start("index.cgi", "post");
	print "<input type='hidden' name='showdiff' value=''>\n";
	print &ui_columns_start(["old config-file","new config-file","delete new","take new","ignore","diff"]);



        foreach (@files) {
    	    $name = uri_escape($_);
	    $sel="ignore";
	    if ($in{$name} ne '') {
		$sel=$in{$name};
	    }
	    $del=ui_oneradio($name,"del_new","del",$sel eq "del_new");
	    $take=ui_oneradio($name,"take_new","take",$sel eq "take_new");
	    $ignore=ui_oneradio($name,"ignore","ignore",$sel eq "ignore");
	    $diff="<a href='#' onClick='document.forms[0].showdiff.value=\"$name\";  document.forms[0].submit()'>show diff</a>";
    	    print &ui_columns_row([$_,$filelist{$_},$del,$take,$ignore,$diff]);
	}

	print &ui_columns_end();
	print &ui_form_end([["save","Save"]]);
    }
}
